/*
 * Copyright 2012, 2017 INFN
 *
 * Licensed under the EUPL, Version 1.2 or – as soon they
 * will be approved by the European Commission - subsequent
 * versions of the EUPL (the "Licence");
 * You may not use this work except in compliance with the
 * Licence.
 * You may obtain a copy of the Licence at:
 *
 * https://joinup.ec.europa.eu/software/page/eupl
 *
 * Unless required by applicable law or agreed to in
 * writing, software distributed under the Licence is
 * distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied.
 * See the Licence for the specific language governing
 * permissions and limitations under the Licence.
 */

#include <chaos_metadata_service_client/api_proxy/groups/DeleteNode.h>

using namespace chaos;
using namespace chaos::common::data;
using namespace chaos::metadata_service_client::api_proxy;
using namespace chaos::metadata_service_client::api_proxy::groups;

API_PROXY_CD_DEFINITION(DeleteNode,
                        "groups",
                        "deleteNode")
/*!
 
 */
ApiProxyResult DeleteNode::execute(const std::string& node_domain,
                                   const std::string& node_name,
                                   const std::string& node_parent_path) {
    CDWUniquePtr pack(new CDataWrapper());
    pack->addStringValue("node_name", node_name);
    pack->addStringValue("node_domain", node_domain);
    pack->addStringValue("node_parent_path", node_parent_path);
    return callApi(pack);
}
